<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref, onUpdated, onMounted, nextTick, onBeforeUnmount, computed } from 'vue';
import { Dialog, DialogPanel, TransitionRoot } from '@headlessui/vue';
import Button from '@/components/general/Button.vue';

const sidebar = ref<HTMLElement>();

const props = defineProps<{
    modelValue?: boolean,
    header?: string,
    labelSubmit?: string,
    font?: string,
    left?: boolean,
    width?: string,
    light?: boolean,
    initialFocus?: HTMLElement
}>();

const isSidebarOpen = ref(props.modelValue);
const showTransition = ref(props.modelValue);

const emits = defineEmits<{
    (e: 'update:modelValue', value: boolean): void,
    (e: 'submit', value?: any): void,
    (e: 'cancel', value?: any): void
}>();

const handleClose = () => {
    showTransition.value = false;
    setTimeout(() => {
        emits('cancel');
    }, 250);
}

const handleSubmit = () => {
    showTransition.value = false;
    setTimeout(() => {
        emits('submit');
    }, 250);
}

const afterLeave = ()=>{
    emits('update:modelValue', false);
}

onMounted(async () => {
    await nextTick();
    isSidebarOpen.value = true;
    showTransition.value = true;
});

onBeforeUnmount(() => {
    showTransition.value = false;
});

const contentHeight = computed(()=>{
    let subtractionHight = 28*2+30;
    if(props.header)
        subtractionHight += 32+4;
    if(props.labelSubmit)
        subtractionHight += 27+4;
    return {height:`calc(100dvh - ${subtractionHight}px)`};
});

const bgColor = computed(()=>{
    return props.light?'bg-gray-300 text-black':'bg-[#181818] text-white';
});

</script>
<template>
    <Dialog :open="isSidebarOpen" as="div" :initialFocus="sidebar">
        <div aria-hidden="true" class="fixed inset-0 bg-black/50 z-[1000] "></div>
        <TransitionRoot :show="showTransition" @after-leave="afterLeave" appear as="template" enter="enter"
            :enter-from="props.left ? 'enter-from-left' : 'enter-from-right'" enter-to="enter-to" leave="leave"
            leave-from="leave-from" :leave-to="props.left ? 'enter-from-left' : 'enter-from-right'">
            <div class="fixed inset-0 flex justify-start z-[1000]" :style="{ justifyContent: props.left ? 'start' : 'end' }">
                <DialogPanel>
                    <div ref="sidebar" class="p-7 relative mb-auto r-0 max-w-full h-dvh overflow-hidden" :class="[font ? font : '', props.left ? 'rounded-r-2xl' : 'rounded-l-2xl', width?width:'w-72', bgColor]">
                        <h3 class="flex flex-col gap-2">
                            <div class="flex flex-row-reverse">
                                <Tooltip :tooltip="$t('general.buttons.close')">
                                    <button class="text-[24px] leading-6 align-middle ml-auto rounded-md p-1" :class="light?'text-black hover:bg-gray-100':'text-white hover:bg-gray-600'" type="button" @click="handleClose"><i class="ri-close-line"></i></button>
                                </Tooltip>
                            </div>
                            <span class="text-2xl" :tabindex="-1" :class="light?'text-black':'text-white'" v-if="header">{{ header }}</span>
                            <div v-if="labelSubmit">
                                <Button variant="confirm" size="small" @click="handleSubmit">{{ labelSubmit }}</Button>
                            </div>
                        </h3>
                        <div class="overflow-auto" :style="contentHeight">
                            <slot></slot>
                        </div>
                    </div>
                </DialogPanel>
            </div>
        </TransitionRoot>
    </Dialog>
</template>
<style scoped>
.enter {
    transition-property: all;
    transition-duration: 250ms;
    transition-timing-function: ease-out;
}

.leave {
    transition-property: all;
    transition-duration: 250ms;
    transition-timing-function: ease-in;
}

.enter-from-right {
    transform: translateX(100%);
}

.enter-from-left {
    transform: translateX(-100%);
}

.enter-leave-to {
    transform: translateX(0);
}
</style>